﻿using System;
using System.Linq;
using Dapper;
using System.Collections.Generic;
using Models;
using Syncfusion.XlsIO;
using Syncfusion.EJ.Export;
using System.Data;
using System.Data.SqlClient;
using Syncfusion.JavaScript.Web;
using System.Collections;
using DocumentFormat.OpenXml.Office2010.ExcelAc;
using Syncfusion.JavaScript.Models;
using System.Web.UI.WebControls;

public partial class AllPlanningUnits : BandPage
{
    #region Sql

    private readonly string GetPlanningUnits = @"
        
        select
        @Entity[Entity],
        @User[User],
        a.project_id,
        b.ext_workpackage_id,
        b.workpackage_code,
        b.name,
        right(b.workpackage_code,3) [Job],
        b.[Allocated_To],
        convert (integer,b.Duration,2) Duration,
        bs.name status,
        convert(varchar, b.earliest_start_date,106) earliest_start,
        convert(varchar, b.latest_completion_date,106) latest_completion,
        b.Created_Date [createddate],
        bt.name type,
        bi.name [billing],
        c2.CC_USRCHAR1 [accessbilling],
        CASE 
			when c2.CC_USRCHAR1=bi.name then '1'
			when c2.CC_USRCHAR1 is null then '0'
			else '-1'
		end [billingmatch],
		
        [workpackage/@iscomplete] = 
                 CASE
                      WHEN bs.completed = 1 THEN 1
		              WHEN bs.completed = 0 THEN 0
                 END
        ,(select SUM(hours)/60 from EXVW_TMShours h where  h.WP like b.workpackage_code + '%' collate SQL_Latin1_General_CP1_CI_AS)[Actual]
        
        ,(select CONVERT(DECIMAL(10,2),SUM(child.Duration)) from EXT_Workpackage child where child.Parent_Workpackage_ID=b.EXT_Workpackage_ID and ext_workpackage_status_id not in (3,13)) [child_duration]
        
        ,CONVERT(DECIMAL(10,2),x1m.CC_ACTUAL_COST) + CONVERT(DECIMAL(10,2),x1m.CC_COMITT_COST) [xm]
        ,CONVERT(DECIMAL(10,2),x1s.CC_ACTUAL_COST) [xs]
         
        ,CONVERT(DECIMAL(10,2),b.material_cost) [est_mat]
        ,a.last_update_time [last_update],CONVERT(DECIMAL(10,2),b.scheduleatotal)[scheduleatotal],ct.Name[contracttype]
        from project a
        join EXT_Workpackage b on a.project_id = b.project_id
        join EXT_Workpackage_Status bs on b.EXT_Workpackage_Status_ID = bs.EXT_Workpackage_Status_ID
        left outer join ext_workpackage_type bt on bt.ext_workpackage_type_id = b.ext_workpackage_type_id
        left join ext_workpackage_billing_type bi on b.billing = bi.ext_workpackage_billing_type_id

		left join Project p on a.project_id=p.project_id
		LEFT JOIN [PendennisShipyardLtd].[dbo].[CST_COSTCENTRE] x1m on b.Workpackage_Code + 'M' = p.Project_Code + x1m.cc_code and x1m.cc_copyheader=p.Project_Code
		LEFT JOIN [PendennisShipyardLtd].[dbo].[CST_COSTCENTRE] x1s on b.Workpackage_Code + 'S' = p.Project_Code + x1s.cc_code and x1s.cc_copyheader=p.Project_Code
			
        LEFT JOIN EXT_workpackage_contract_type ct on b.EXT_Workpackage_Contract_Type_ID=ct.EXT_Workpackage_Contract_Type_ID
        left join [PendennisShipyardLtd].[dbo].CST_COSTCENTRE2 c2 on x1m.CC_primary = c2.CC_PRIMARY_2
 
        left join ext_workpackage_approvable_projects wpp on a.Project_ID=wpp.project_id 
        
        where a.project_id = @Entity
        and b.Parent_Workpackage_ID is null
        
        and bt.ext_workpackage_type_id = @Parameter
		ORDER BY EXT_Workpackage_ID DESC

";

    #endregion Sql



    public IEnumerable<PlanningUnits> GetPlanningUnitDetails(bool hideComplete)
    {
        using (var connection = ConnectionService.CreateConnection())
        {
            var planningUnits = connection.Query<PlanningUnits>(GetPlanningUnits, new { Entity = Entity.EntityID, User = UserID, Parameter = Parameter });

            planningUnits = planningUnits.ToList();

            return planningUnits;
        }
    }

    protected void Grid_ServerExcelExporting(object sender, Syncfusion.JavaScript.Web.GridEventArgs e)
    {
        //ExcelExport exp = new ExcelExport();
        //exp.Export(PlanningUnitsGrid.Model, (IEnumerable)PlanningUnitsGrid.DataSource, "Export.xlsx", ExcelVersion.Excel2010, true, true, "flat-lime");
        BindGrid();
        ExcelExport exp = new ExcelExport();
        //GridProperties obj = ConvertGridObject(GridModel);
        exp.Export(PlanningUnitsGrid.Model, PlanningUnitsGrid.DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, ExportTheme.BootstrapTheme);

    }

    protected void Page_Load(object sender, EventArgs e)
    {

        this.PlanningUnitsGrid.Model.Columns[2].Tooltip = "Code";
        this.PlanningUnitsGrid.Model.Columns[3].Tooltip = "Job";
        this.PlanningUnitsGrid.Model.Columns[4].Tooltip = "Name";
        this.PlanningUnitsGrid.Model.Columns[5].Tooltip = "Billing";
        this.PlanningUnitsGrid.Model.Columns[6].Tooltip = "Sales Budget";
        this.PlanningUnitsGrid.Model.Columns[7].Tooltip = "Estimated Material";
        this.PlanningUnitsGrid.Model.Columns[8].Tooltip = "Schedule A Total";
        this.PlanningUnitsGrid.Model.Columns[9].Tooltip = "Actual";
        this.PlanningUnitsGrid.Model.Columns[10].Tooltip = "Contract";
        this.PlanningUnitsGrid.Model.Columns[11].Tooltip = "Description";
        this.PlanningUnitsGrid.Model.Columns[12].Tooltip = "Status";
        this.PlanningUnitsGrid.Model.Columns[13].Tooltip = "Job Number";

        this.PlanningUnitsGrid.Columns[5].DataSource = "billing";




        //PlanningUnits planningUnits = new PlanningUnits();

        //lblNavigateUrl.Text = "<a rel='nofollow' href='/XWeb-Dev02/customised/general/Pendennis/PSY_Workpackage/Bands/psy_create_wp_norms.aspx?pj=" + Entity.EntityID + "&user=" + UserID + " target='_blank'><i class=\"fas fa-plus fa blue\"></i><span class=\"fa - layers - text fa - inverse\" data-fa-transform=\"shrink - 11.5 rotate--30\" style=\"font=\"Helvetica\" - weight:900\"></span></a>";

        //this.gridHidden.DataSource = GetPlanningUnitDetails(false);

        //this.gridHidden.DataBind();

        this.Session["Parameter"] = Parameter.ToString();

        this.Session["Entity"] = Entity.EntityID.ToString();

        this.Session["User"] = UserID.ToString();

    }


    private void BindGrid()
    {
        PlanningUnitsGrid.DataSource = GetPlanningUnitDetails(false);
        PlanningUnitsGrid.DataBind();
    }

    protected void Grid_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (e.Row.RowType != DataControlRowType.DataRow)
        {
            return;
        }

        var model = e.Row.DataItem as PlanningUnits;

    }

    protected void ExcelButton_Click(object sender, EventArgs e)
    {
        ExportService.ExportGrid(Response, gridHidden);
    }

    public class PlanningUnits
    {
        //public string Navigate_URL = "" + "<a href=\"" + "http://" + "project_milestones_form.aspx?u=" + UserID + "&amp;e&#61;" + Entity.ID + " target = \"_blank\" > <img src=\"rtr_button.png\"/></ a > ";
        public int EXT_Workpackage_ID { get; set; }
        public string workpackage_code { get; set; }
        public string name { get; set; }
        public string Job { get; set; }
        public string status { get; set; }
        public string billing { get; set; }
        public string Allocated_To { get; set; }
        public string createdate { get; set; }
        public string earliest_start_date { get; set; }
        public string last_update { get; set; }
        public int budget { get; set; }
        public int Actual { get; set; }
        public int child_duration { get; set; }
        public int est_mat { get; set; }
        public int scheduleatotal { get; set; }
        public string contracttype { get; set; }
        public string latest_completion { get; set; }
        public int Entity { get; set; }
        public int Duration { get; set; }
        public int xm { get; set; }
        public int xs { get; set; }
    }
}